package algorithm;

import java.util.*;

import helpers.*;
import model.*;

public class Smoother {
	
	public static final int CONSTIT_SMOOTHER = 2;
	public static final int DISTIT_SMOOTHER = 8;
	
	/**
	 * add counts to the sequences and contexts according to constants
	 * @param params 
	 */
	public static void smoothCCM(Parameters params)
	{
		DoubleMap<Sequence> constits = params.getConstits();
		Iterator<Sequence> sequenceIter = constits.keySet().iterator();
		while(sequenceIter.hasNext())
			constits.inc(sequenceIter.next(),CONSTIT_SMOOTHER);
			
		DoubleMap<Sequence> distits = params.getDistits();
		sequenceIter = distits.keySet().iterator();
		while(sequenceIter.hasNext())
			distits.inc(sequenceIter.next(),DISTIT_SMOOTHER);
				
		DoubleMap<Context> constitCntxt = params.getConstitCntxt();
		Iterator<Context> contextIter = constitCntxt.keySet().iterator();
		while(contextIter.hasNext())
			constitCntxt.inc(contextIter.next(),CONSTIT_SMOOTHER);
		
		DoubleMap<Context> distitCntxt = params.getDistitCntxt();
		contextIter = distitCntxt.keySet().iterator();
		while(contextIter.hasNext())
			distitCntxt.inc(contextIter.next(),DISTIT_SMOOTHER);	
	}
}
