package helpers;

import java.util.*;
import java.io.*;
import main.*;
import model.TreeNode;

public class Converter {
	
	public static Vector<TreeNode> wsjToAdiosRecurse(String name)
	{
		Vector<TreeNode> result = new Vector<TreeNode>();
		
		File path = new File(Finals.WORKING_DIR+name);
		if(path.isFile())
		{
			if(name.endsWith(".MRG"))
			{
				System.out.println("converting file: " + name);
				return wsjToAdios(name);
			}
			else 
				return result;
		}
		else
		{
			String[] fileList = path.list();
			for(int i = 0; i < fileList.length;++i)
				result.addAll(wsjToAdiosRecurse(name+"/"+fileList[i]));
			return result;
		}
	}
	
	public static Vector<TreeNode> wsjToAdios(String fileName)
	{
		Vector<TreeNode> result = new Vector<TreeNode>();
		int bracketCounter = 0;
		try
		{
			BufferedReader br = FileHelper.startReading(Finals.WORKING_DIR+fileName);
			String line = null;
			StringBuffer sb = new StringBuffer();
			boolean add = false;
			while((line = br.readLine())!=null)
			{
				sb.append(line);
				for(int i = 0; i < line.length();++i)
				{
					if(line.charAt(i)=='(')
					{
						add = true;
						bracketCounter++;
					}
					else if(line.charAt(i)==')')
						bracketCounter--;
				}
				if(bracketCounter==0 && add)
				{
					TreeNode tree = new TreeNode(sb.toString(),TreeNode.BRACKETS);
					tree = tree.prunePunctationAndEmpties(); 
					if(tree.getLength()<=10)
						result.add(tree);
					sb = new StringBuffer();
					add = false;
				}				
			}
			br.close();
			
		}
		catch(IOException e)
		{
			e.printStackTrace();
		}
		
		return result;
	}
	
	public static void main(String[] args)
	{
		Vector<TreeNode> trees = wsjToAdiosRecurse("");
		TreeNode.printTrees(trees);
		TreeNode.printPoss(trees);
		
	}
}
