/*
 * Created on May 13, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package helpers;

import java.util.*;

/**
 * @author Administrator
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class CountMap<K> implements Cloneable {
	private HashMap<K, Integer> count;
	private int total;
	private double entropy;
	private boolean entropyCached;


	public CountMap() {
		count = new HashMap<K,Integer>();
		total = 0;
		entropyCached = false;
	} 
	
	public void inc(K obj) {
		Integer i = (Integer)count.get(obj);
		
		if (i==null) 
			count.put(obj, new Integer(1));
		else
			count.put(obj, new Integer(i.intValue()+1));
		
		total++;
		entropyCached = false;
	}
	
	public void inc(K obj, int n) {
		Integer i = (Integer)count.get(obj);
		
		if (i==null) 
			count.put(obj, new Integer(n));
		else
			count.put(obj, new Integer(i.intValue()+n));
		
		total+=n;
		entropyCached = false;
	}
	
	public void dec(K obj) {
		Integer i = (Integer)count.get(obj);
		
		if (i==null) {
			System.out.println("Decrementing null key in CountMap - " + obj);
			System.exit(1);
		}
		
		if (i.intValue()==1) 
			count.remove(obj);
		else
			count.put(obj, new Integer(i.intValue()-1));
		
		total--;
		entropyCached = false;
	}
	
	public void add(CountMap<K> cm) {
		Iterator<K> it = cm.keySet().iterator();
		
		while (it.hasNext()) {
			K key = it.next();
			this.inc(key, cm.getCount(key));
		}
		entropyCached = false;
	}
	
	public int getCount(Object obj) {
		Integer i = (Integer)count.get(obj);
		return i==null ? 0 : i.intValue();
	}
	
	public double[] getProbs() {
	    double[] probs = new double[count.size()];
	    Iterator it = count.values().iterator();
	    int i = 0;
	    
	    while (it.hasNext()) {
	        probs[i] = ((Integer)it.next()).doubleValue() / total;
	        i++;
	    }
	    
	    return probs;
	}
	
	public double getProb(Object key) {
		if (count.get(key)== null)
			return 0;
	    return ((Integer)count.get(key)).doubleValue() / total;
	}
	
	public int getTotal() {
		return total;
	}
	
	public Set<K> keySet() {
		return count.keySet();
	}
	
	public Set entrySet() {
		return count.entrySet();
	}
	
	public Collection values() {
		//return count.entrySet();
		return count.values();
	}
	
	public Vector valuesVector() {
	    Vector<Integer> vec = new Vector<Integer>();
	    Iterator<Integer> it = count.values().iterator();
	    
	    while (it.hasNext()) 
	        vec.add(it.next());
	    
	    return vec;
	}
	
	public HashMap getCount() {
	    return this.count;
	}
	
	public Collection keys() {
		Vector<K> vec = new Vector<K>();
		Iterator<K> it = count.keySet().iterator();
		
		while (it.hasNext())
			vec.add(it.next());
		
		return vec;
	}
	
	public int size() {
	    return count.size();
	}
	
	public Object clone() {
	    CountMap<K> cm = new CountMap<K>();
	    
	    cm.count = (HashMap)count.clone();
	    cm.total = total;
	    cm.entropy = entropy;
	    cm.entropyCached = entropyCached;
	    
	    return cm;
	}
	
	public String toString() {
	    return count.toString();
	}
	
	public double logLikelihood(CountMap probMap) {
	    double res = 0;
	    Iterator keyIt = count.keySet().iterator();
	    
	    while (keyIt.hasNext()) {
	        Object key = keyIt.next();
	        int i = this.getCount(key);
	        double pi = probMap.getProb(key);
	        
	        res += MathFuncs.log2(pi)*i;
	    }
	    
	    return res;
	}
	
	public double logLikelihood() {
	    double res = 0;
	    Iterator keyIt = count.keySet().iterator();
	    
	    while (keyIt.hasNext()) {
	        Object key = keyIt.next();
	        int i = this.getCount(key);
	        double pi = (double)i / total;
	        
	        res += MathFuncs.log2(pi)*i;
	    }
	    
	    return res;
	}
	
	public int[] getHistogram() {
	    int[] h = new int[total+1];
	    
	    Iterator it = count.values().iterator();
	    while (it.hasNext()) 
	        h[((Integer)it.next()).intValue()]++;
	    
	    return h;
	}
	
	
	public double entropyMean() {
	    return entropy;
	}
	
	public double entropyMLE() {
	    if (!entropyCached) {
		    entropy = 0;
			
			Iterator it = count.values().iterator();
			while(it.hasNext()) {
				double prob = ((Integer)it.next()).doubleValue() / total;
				
				entropy -= prob*MathFuncs.log2(prob);
			}
			
			entropyCached = true;
	    }
	    
	    return entropy;
	}
	
	public double entropyMM() {
	    return entropyMLE() + (count.size()-1)/((double)2*total);
	}
	
	public double entropyJK() {
	    double ent = entropyMLE() * total;
	    
	    Iterator it = count.keySet().iterator();
	    while(it.hasNext()) {
	        Object nextKey = it.next();
	        int keyCount = getCount(nextKey);
	        
	        double tmpEntropy = 0;
	        Iterator tmpIt = count.keySet().iterator();
			while(tmpIt.hasNext()) {
			    double prob;
			    Object tmpKey = tmpIt.next();
			    
			    if (tmpKey == nextKey)
			        prob = ((double)getCount(tmpKey)-1)/(total-1);
			    else
			        prob = ((double)getCount(tmpKey))/(total-1);
			    
				tmpEntropy -= prob*MathFuncs.log2(prob);
			}
	        
	        ent -= ((double)(total-1))/total * keyCount * tmpEntropy;
	    }
	    
	    return ent;
	}
}
