/*
 * Created on May 13, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package helpers;

import java.util.*;

/**
 * @author Administrator
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class DoubleMap<K extends Comparable> implements Cloneable {
	private HashMap<K, Double> count;
	private double total;
	
	public DoubleMap() {
		count = new HashMap<K, Double>();
		total = 0;
	} 
	
	public DoubleMap(DoubleMap<K> other) {
		count = new HashMap<K, Double>(other.count);
		total = other.total;
	}
	
	public void inc(K obj) {
		Double i = (Double)count.get(obj);
		
		if (i==null) 
			count.put(obj, new Double(1));
		else
			count.put(obj, new Double(i.doubleValue()+1));
		
		total++;
	}
	
	public void inc(K obj, double n) {
		Double i = (Double)count.get(obj);
		
		if (i==null) 
			count.put(obj, new Double(n));
		else
			count.put(obj, new Double(i.doubleValue()+n));
		
		total+=n;
	}
	
	public void incexp(K obj, double n) {
		Double i = (Double)count.get(obj);
		
		if (i==null) { 
			count.put(obj, new Double(n));
			total += n;
		} else {
			double i2 = Math.exp(i.doubleValue())+Math.exp(n);
			count.put(obj, new Double((Math.log(i2))));
			total -= i.doubleValue();
			total += i2;
		}
	}
	/**
	 * @param obj 
	 * @param n
	 * @return true if some update was preformed in the table
	 */
	public boolean maxexp(K obj, double n)
	{
		Double i = (Double)count.get(obj);
		
		if (i==null) { 
			count.put(obj, new Double(n));
			total += n;
			return true;
		} else {
			if (n > i.doubleValue())
			{
				double i2 = Math.exp(n);
				count.put(obj, new Double((Math.log(i2))));
				total -= i.doubleValue();
				total += i2;
				return true;
			}
			return false;		
		}
	}
	
	public void dec(K obj) {
		Double i = (Double)count.get(obj);
		
		if (i==null) {
			System.out.println("Decrementing null key in DoubleMap - " + obj);
			System.exit(1);
		}
		
		if (i.doubleValue()==1) 
			count.remove(obj);
		else
			count.put(obj, new Double(i.doubleValue()-1));
		
		total--;
	}
	
	public void dec(K obj, int n) {
		Double i = (Double)count.get(obj);
		
		if (i==null) {
			System.out.println("Decrementing null key in CountMap - " + obj);
			System.exit(1);
		}
		
		if (i.doubleValue()<=n) { 
			count.remove(obj);
			total -= i.doubleValue();
		} else {
			count.put(obj, new Double(i.doubleValue()-1));
			total -= n;
		}
	}
	
	public void set(K obj, double val) {
	    double c = get(obj);
	    count.put(obj, new Double(val));
	    total = total - c + val;
	}
	
	public void add(DoubleMap<K> cm) {
		Iterator<K> it = cm.keySet().iterator();
		
		while (it.hasNext()) {
			K key = it.next();
			this.inc(key, cm.get(key));
		}
	}
	
	public void subtract(DoubleMap<K> cm) {
	    Iterator<K> it = cm.keySet().iterator();
		
		while (it.hasNext()) {
			K key = it.next();
			this.inc(key, -cm.get(key));
		}
	}
	
	public double get(K obj) {
		Double i = (Double)count.get(obj);
		return i==null ? 0 : i.doubleValue();
	}
	
	public double[] getProbs() {
	    double[] probs = new double[count.size()];
	    Iterator it = count.values().iterator();
	    int i = 0;
	    
	    while (it.hasNext()) {
	        probs[i] = ((Double)it.next()).doubleValue() / total;
	        i++;
	    }
	    
	    return probs;
	}
	
	public double entropyMLE() {
	    double ent = 0;
		
		Iterator it = count.values().iterator();
		while(it.hasNext()) {
			double prob = ((Double)it.next()).doubleValue() / total;
			
			ent -= prob*MathFuncs.log2(prob);
		}
		
		return ent;
	}
	
	public double getTotal() {
		return total;
	}
	
	public boolean containsKey(K key) {
		return count.containsKey(key);
	}
	
	public Set<K> keySet() {
		return count.keySet();
	}
		
	public Set<Map.Entry<K, Double>> entrySet() {
		return count.entrySet();
	}
	
	public Vector sortedEntryVector() {
	    Vector vec = new Vector();
	    Iterator it = count.entrySet().iterator();
	    
	    while (it.hasNext()) 
	        vec.add(new OrderedEntry((Map.Entry)it.next()));
	    
	    Collections.sort(vec);
	    Vector vec2 = new Vector();
	    it = vec.iterator();
	    
	    while (it.hasNext())
	        vec2.add(((OrderedEntry)it.next()).entry);
	    
	    return vec2;
	}
	
	public Collection values() {
		//return count.entrySet();
		return count.values();
	}
	
	public Vector<Double> valuesVector() {
	    Vector<Double> vec = new Vector<Double>();
	    Iterator<Double> it = count.values().iterator();
	    
	    while (it.hasNext()) 
	        vec.add(it.next());
	    
	    return vec;
	}
	
	public HashMap getCount() {
	    return this.count;
	}
	
	public Collection keys() {
		Vector<K> vec = new Vector<K>();
		Iterator<K> it = count.keySet().iterator();
		
		while (it.hasNext())
			vec.add(it.next());
		
		return vec;
	}
	
	public int size() {
	    return count.size();
	}
	
	public void clear() {
		count.clear();
		total = 0;
	}
	
	public Object clone() {
	    DoubleMap<K> cm = new DoubleMap<K>();
	    cm.count = new HashMap<K, Double>(count);
	    
	    return cm;
	}
	
	public String toString() {
	    return count.toString();
	}
	
	public void smooth(int threshold) {
		HashSet<K> toRemove = new HashSet<K>();
		
		for (K key : count.keySet()) {
			double v = count.get(key);
			if (v <= threshold) {
				toRemove.add(key);
				total -= v;
			}
		}
		
		for (K key : toRemove)
			count.remove(key);
	}
	
	public static double angle(DoubleMap dm1, DoubleMap dm2) {
		Iterator<Map.Entry> it1 = dm1.count.entrySet().iterator();
		Iterator<Map.Entry> it2 = dm2.count.entrySet().iterator();
		
		if (!it1.hasNext() || !it2.hasNext())
			return Double.MAX_VALUE;
		
		double c=0, n1=0, n2=0;
		Map.Entry me1 = it1.next();
		Map.Entry me2 = it2.next();
		
		n1 += ((Double)me1.getValue()).doubleValue()*((Double)me1.getValue()).doubleValue();
		n2 += ((Double)me2.getValue()).doubleValue()*((Double)me2.getValue()).doubleValue();
		
		while (true) {
			if (me1.getKey().equals(me2.getKey())) {
				c += ((Double)me1.getValue()).doubleValue()*((Double)me2.getValue()).doubleValue();
				if (!it1.hasNext()) {
					while (it2.hasNext()) {
						me2 = it2.next();
						n2 += ((Double)me2.getValue()).doubleValue()*((Double)me2.getValue()).doubleValue();
					}
					
					return Math.acos(Math.min(c / Math.sqrt(n1) / Math.sqrt(n2), 1));
				} else if (!it2.hasNext()) {
					while (it1.hasNext()) {
						me1 = it1.next();
						n1 += ((Double)me1.getValue()).doubleValue()*((Double)me1.getValue()).doubleValue();
					}
					
					return Math.acos(Math.min(c / Math.sqrt(n1) / Math.sqrt(n2), 1));
				} else {
					me1 = it1.next();
					me2 = it2.next();
					n1 += ((Double)me1.getValue()).doubleValue()*((Double)me1.getValue()).doubleValue();
					n2 += ((Double)me2.getValue()).doubleValue()*((Double)me2.getValue()).doubleValue();
				}
			} else if (((Comparable)me1.getKey()).compareTo(me2.getKey()) < 0) {
				if (it1.hasNext()) {
					me1 = it1.next();
					n1 += ((Double)me1.getValue()).doubleValue()*((Double)me1.getValue()).doubleValue();
				} else {
					while (it2.hasNext()) {
						me2 = it2.next();
						n2 += ((Double)me2.getValue()).doubleValue()*((Double)me2.getValue()).doubleValue();
					}
					
					return Math.acos(Math.min(c / Math.sqrt(n1) / Math.sqrt(n2), 1));
				}
			} else {
				if (it2.hasNext()) {
					me2 = it2.next();
					n2 += ((Double)me2.getValue()).doubleValue()*((Double)me2.getValue()).doubleValue();
				} else {
					while (it1.hasNext()) {
						me1 = it1.next();
						n1 += ((Double)me1.getValue()).doubleValue()*((Double)me1.getValue()).doubleValue();
					}
					
					return Math.acos(Math.min(c / Math.sqrt(n1) / Math.sqrt(n2), 1));
				}
			}
		}
	}
	
	public static double jaccard(DoubleMap dm1, DoubleMap dm2) {
		Iterator<Map.Entry> it1 = dm1.count.entrySet().iterator();
		Iterator<Map.Entry> it2 = dm2.count.entrySet().iterator();
		
		if (!it1.hasNext() || !it2.hasNext())
			return Double.MAX_VALUE;
		
		double c=0, n1=0, n2=0;
		Map.Entry me1 = it1.next();
		Map.Entry me2 = it2.next();
		
		while (true) {
			if (me1.getKey().equals(me2.getKey())) {
				c++;
				if (!it1.hasNext()) {
					while (it2.hasNext()) {
						it2.next();
						n2++;
					}
					
					return 1.0 - c / (n1+n2);
				} else if (!it2.hasNext()) {
					while (it1.hasNext()) {
						it1.next();
						n1++;
					}
					
					return 1.0 - c / (n1+n2);
				} else {
					me1 = it1.next();
					me2 = it2.next();
				}
			} else if (((Comparable)me1.getKey()).compareTo(me2.getKey()) < 0) {
				n1++;
				if (it1.hasNext()) 
					me1 = it1.next();
				else {
					while (it2.hasNext()) {
						it2.next();
						n2++;
					}
					
					return 1.0 - c / (n1+n2);
				}
			} else {
				n2++;
				if (it2.hasNext()) {
					me2 = it2.next();
				} else {
					while (it1.hasNext()) {
						it1.next();
						n1++;
					}
					
					return 1.0 - c / (n1+n2);
				}
			}
		}
		
		/*Set commonKeys = new HashSet(dm1.keySet());
		commonKeys.retainAll(dm2.keySet());

		Set totalKeys = new HashSet(dm1.keySet());
		Set tmp = new HashSet(dm2.keySet());
		tmp.removeAll(totalKeys);
		
		return 1.0 - ((double)commonKeys.size())/(totalKeys.size() + tmp.size());*/		
	}
	
	private class OrderedEntry implements Comparable {
	    private Map.Entry entry;
	    
	    OrderedEntry(Map.Entry entry) {
	        this.entry = entry;
	    }
	    
	    public int compareTo(Object o) {
	        return ((Comparable)entry.getValue()).compareTo(((OrderedEntry)o).getValue());
	    }
	    
	    public Object getValue() {
	        return entry.getValue();
	    }
	    
	    public Object getKey() {
	        return entry.getKey();
	    }
	}
}
