package helpers;

import java.util.*;
import java.io.*;
import main.Finals;

public class FileHelper {
	static Vector<PrintWriter> pws = new Vector<PrintWriter>();
	static Vector<FileOutputStream> foss = new Vector<FileOutputStream>();
	
	public static PrintWriter startWriting(String relPath, boolean append) {
		try {
			FileOutputStream fos = new FileOutputStream(Finals.WORKING_DIR + relPath, append);
			PrintWriter pw = new PrintWriter(fos);
			
			pws.add(pw);
			foss.add(fos);
			
			return pw;
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
		
		return null;
	}
	
	public static void finished(PrintWriter pw) {
		for (int i=0; i<pws.size(); i++) 
			if (pws.get(i) == pw) {
				pw.close();
				try {
					foss.get(i).close();
				} catch (Exception e) {
					e.printStackTrace();
					System.exit(1);
				}
				
				pws.remove(i);
				foss.remove(i);
				
				return;
			}
		
		System.out.println("No such PrintWriter!!!");
		System.exit(1);
	}
	
	public static BufferedReader startReading(String fullPath) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(fullPath));
			return br;
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
		
		return null;
	}
	
	public static void finished(BufferedReader br) {
		try {
			br.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	public static void printAll(String fullPath, Vector<String> sentences) {
		PrintWriter pw = startWriting(fullPath, false);
		for (String s : sentences)
			pw.println(s);
		
		finished(pw);
	}
	
	public static Vector<String> readAll(String relPath) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(Finals.WORKING_DIR + relPath));
			Vector<String> res = new Vector<String>();
			String line;
			
			while ((line = br.readLine()) != null) {
				/*StringTokenizer st = new StringTokenizer(line);
				StringBuffer sb = new StringBuffer();
				
				while (st.hasMoreTokens()) {
					sb.append(st.nextToken());
					if (st.hasMoreTokens())
						sb.append(' ');
				}
				
				res.add(sb.toString());*/
				res.add(line);
			}

			br.close();
			return res;
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
		
		return null;
	}
}
