/*
 * Created on May 7, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package helpers;

import java.util.*;

/**
 * @author sandban
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class MultiMap<K, V> {
    private HashMap<K, HashSet<V>> map;
    private int hash;
    
    public MultiMap() {
        map = new HashMap<K, HashSet<V>>();
    }
    
    public void addValue(K key, V val) {
        if (!map.containsKey(key))
            map.put(key, new HashSet<V>());
        
        HashSet<V> set = map.get(key);
        //if (!set.contains(val))
        set.add(val);
    }
    
    public void deleteValue(K key, V val) {
        if (!map.containsKey(key))
            return;
        
        HashSet<V> set = map.get(key);
        set.remove(val);
        if (set.size() == 0)
            map.remove(key);
    }
    
    public boolean contains(K key, V value) {
        HashSet<V> set = map.get(key);
        if (set == null) 
            return false;
        
        return set.contains(value);
    }
    
    public boolean containsKey(K key) {
    	return !(map.get(key) == null);
    }
    
    public void removeKey(K key) {
    	map.remove(key);
    }
    
    public void addAll(MultiMap<K, V> other) {
    	for (K key : other.keySet()) {
    		HashSet<V> vals;
    		if (!map.containsKey(key)) {
    			vals = new HashSet<V>();
    			map.put(key, vals);
    		} else
    			vals = map.get(key);
    		
    		vals.addAll(other.getAll(key));
    	}
    }
    
    public Iterator<V> iterator(K key) {
        return map.get(key).iterator();
    }
    
    public Iterator<K> keysIterator() {
        return map.keySet().iterator();
    }
    
    public Set<K> keySet() {
    	return map.keySet();
    }
    
    public void clear(K key) {
        map.remove(key);
    }
    
    public void clear() {
        map.clear();
    }
    
    public int size() {
    	int s = 0;
    	for (HashSet<V> h : map.values()) {
    		s += h.size();
    	}
    	
    	return s;
    }
    
    public HashSet<V> getAll(K key) {
        HashSet<V> hs = map.get(key);
        if (hs == null) {
            hs = new HashSet<V>();
            map.put(key, hs);
        }
        
        return hs;
    }
    
    public MultiMap duplicate() {
        MultiMap<K, V> mm = new MultiMap<K, V>();
        Iterator<K> it = map.keySet().iterator();
        while (it.hasNext()) {
            K key = it.next();
            mm.map.put(key, map.get(key));
        }
        
        return mm;
    }
    
    public String toString() {
        StringBuffer sb = new StringBuffer("[");
        Iterator<K> keysIt = map.keySet().iterator();
        while (keysIt.hasNext()) {
            K key = keysIt.next();
            sb.append(key + "-[");
            
            HashSet<V> hs = map.get(key);
            Iterator<V> it = hs.iterator();
            while (it.hasNext()) {
                sb.append(it.next());
                if (it.hasNext())
                    sb.append(":");
            }
            sb.append("]");
            if (keysIt.hasNext())
                sb.append(";");
        }
        
        sb.append("]");
        return sb.toString();
    }
    
    public void setHashValue() {
    	hash = toString().hashCode();
    }
    
    public int hashCode() {
    	return hash;
    }
    
    public boolean equals(Object o) {
    	return map.equals(((MultiMap<K, V>)o).map);
    }
}
