package model;

import java.util.*;

public class Bracketing extends Vector<Double[]>{
	
	private static final long serialVersionUID = 1L;

	public Bracketing(Vector<String> sent)
	{
		super(sent.size()+1);
		for(int i = 0; i <= sent.size(); i++)
			add(new Double[i+1]);	
		
		//zero the diagonal
		for(int i = 0; i<=sent.size();++i)
			get(i)[i] = new Double(0);
	}
	
	/**
	 * to allow use of vectors of different sizes we need to switch the 
	 * indexing
	 * @param i - start of span
	 * @param j - end of span
	 * @return
	 */
	
	public Double get(int i, int j)
	{
		if(i >= size())
			return null;
		return this.get(j)[i];
	}
	
	public void set(int i, int j, double count)
	{
		this.get(j)[i] = count;	
	}
}
