package model;

import java.util.*;

public class Context implements Comparable{
	
	private String _left;
	private String _right;
	
	public Context(String left,String right)
	{
		_left = left;
		_right = right;
	}
	
	/**
	 * we create a context inclusively according to subseq
	 * @param sent
	 * @param subseq 
	 */
	public Context(Vector<String> sent, SubseqRange subseq)
	{
		if(subseq.getFrom()==0)
			_left = "*";
		else
			_left = sent.get(subseq.getFrom()-1);
		if(subseq.getTo()==sent.size()-1)
			_right = "#";
		else
			_right = sent.get(subseq.getTo()+1);
	}
	
	public String getLeft()
	{
		return _left;
	}
	
	public String getRight()
	{
		return _right;
	}
	
	public void setLeft(String left)
	{
		_left = left;
	}
	
	public void setRight(String right)
	{
		_right = right;
	}
	
	public String toString()
	{
		return _left + " -- " + _right;
	}
	
	public int hashCode()
	{
		return toString().hashCode();
	}
	
	public boolean equals(Object o)
	{
		if(!(o instanceof Context))
			return false;
		
		Context other = (Context) o;
		return _left.equals(other._left) && _right.equals(other._right); 
	}

	public int compareTo(Object o) {
		return toString().compareTo(o.toString());
	}
}
