package model;


public class SubseqRange implements Comparable<SubseqRange>
{
	private int _from;
	private int _to;

	public SubseqRange(int from, int to)
	{
		_from = from;
		_to = to;
	}
	
	public boolean equals(Object obj)
	{
		if (!(obj instanceof SubseqRange))
			return false;
		SubseqRange subseq = (SubseqRange) obj;
		return (subseq._from == _from && subseq._to == _to);
	}
	public String toString()
	{
		return "["+_from+":"+_to+"]";
	}
	
	public int hashCode()
	{
		return toString().hashCode();
	}
	public int compareTo(SubseqRange o) {
		if (this._from > o._from)
			return 1;
		if (this._from < o._from)
			return -1;
		return this._to - o._to;

	}
	public int getFrom()
	{
		return _from;
	}
	public int getTo()
	{
		return _to;
	}
	public void setFrom(int from)
	{
		_from = from;
	}
	public void setTo(int to)
	{
		_to = to;
	}
}